﻿//Copyright Warren Harding 2011-2012.  All rights reserved.
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Functional;
namespace Logic
{
    public class Combinatorics
    {
        public static List<Int32[]> NBaseIndexes(Int32[] inComponentsPerDimension)
        {
            Int32 dimensionIndex;
            Int32[] indexes = new Int32[inComponentsPerDimension.Length];

            Int32 totalComponents = TotalComponentsFromDimensionSizes(inComponentsPerDimension);
            List<Int32[]> lOut = new List<int[]>();
            Int32[] componentsPerDimension = inComponentsPerDimension;
            Int32[] components = new int[totalComponents];
            Int32[] indexSet = new Int32[inComponentsPerDimension.Length];
            int componentIndex = 0;
            indexes[indexes.Length - 1] = -1;
            for (componentIndex = 0; componentIndex < totalComponents; componentIndex++)
            {
                dimensionIndex = inComponentsPerDimension.Length - 1;
            IncrementComponent:
                indexes[dimensionIndex]++;
                if (indexes[dimensionIndex] == inComponentsPerDimension[dimensionIndex])
                {
                    indexes[dimensionIndex] = 0;
                    dimensionIndex--;
                    if (dimensionIndex >= 0)
                    {
                        goto IncrementComponent;
                    }
                }
                components = Functional.Maps.Map(indexes);
                lOut.Add(components);
            }
            return lOut;
        }

        public static Int32[] ComponentsPerDimension<T>(List<List<T>> grid)
        {
            return Maps.Map(grid, x=>x.Count).ToArray();
        }

        public static List<List<T>> CombinatoricSets<T>(List<List<T>> inSets)
        {
            Int32[] componentsPerDimensions = ComponentsPerDimension(inSets);
            List<Int32[]> indexesList = NBaseIndexes(componentsPerDimensions);
            Int32 dimensionIndex, index, listIndex;
            Int32 rank = inSets.Count;
            List<T> set;
            T t;
            List<List<T>> sets = new List<List<T>>();
            for (listIndex = 0; listIndex < indexesList.Count; listIndex++)
            {
                set = new List<T>();
                for (dimensionIndex = 0; dimensionIndex < rank; dimensionIndex++)
                {
                    index = indexesList[listIndex][dimensionIndex];
                    t = inSets[dimensionIndex][index];
                    set.Add(t);
                }
                sets.Add(set);
            }
            return sets;
        }

        public static Int32 TotalComponentsFromDimensionSizes(Int32[] inComponentsPerDimension)
        {
            Int32 L;
            Int32 lOut = 1;
            for (L = 0; L < inComponentsPerDimension.Length; L++)
            {
                lOut = lOut * inComponentsPerDimension[L];
            }
            return lOut;
        }
    }
}
