﻿//Copyright Warren Harding 2011-2012.  All rights reserved.
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Logic
{
    public class Concatenations
    {
        public static List<T[]> UnConcatenate<T>(T[] inputs, int subVectorLength)
        {
            List<T[]> lOut = new List<T[]>();
            List<T> subVector;
            Int32 L1, L2, L3;
            L3 = 0;
            Int32 totalSubVectorsI = inputs.Length / subVectorLength;
            Double totalSubVectorsD;
            if (totalSubVectorsI * subVectorLength != inputs.Length)
            {
                totalSubVectorsD = Convert.ToDouble(inputs.Length) / Convert.ToDouble(subVectorLength);
                totalSubVectorsD = Math.Ceiling(totalSubVectorsD);
                totalSubVectorsI = Convert.ToInt32(totalSubVectorsD);
            }

            for (L1 = 0; L1 < totalSubVectorsI; L1++)
            {
                subVector = new List<T>();
                for (L2 = 0; L2 < subVectorLength; L2++)
                {
                    if (L3 >= inputs.Length)
                    {
                        break;
                    }
                    subVector.Add(inputs[L3]);
                    L3++;
                }
                //lOut[L1] = subVector;
                lOut.Add(subVector.ToArray());
            }
            return lOut;
        }

        public static List<List<T>> UnConcatenate<T>(List<T> inList, int width, int height)
        {
            Int32 L1, L2, count = 0;
            List<List<T>> a1 = new List<List<T>>();
            List<T> a2;
            for (L1 = 0; L1 < height; L1++)
            {
                a2 = new List<T>();
                for (L2 = 0; L2 < width; L2++)
                {
                    a2.Add(inList[count]);
                    count++;
                }
                a1.Add(a2);
            }
            return a1;
        }

        public static T[] Concatenate<T>(List<T>[] input)
        {
            Int32 L;
            List<T> lOut = new List<T>();
            for (L = 0; L < input.Length; L++)
            {
                lOut.AddRange(input[L]);
            }
            return lOut.ToArray();
        }

        public static T[] Concatenate<T>(List<T[]> input)
        {
            Int32 L1,L2;
            List<T> lOut = new List<T>();
            T[] a;
            for (L1 = 0; L1 < input.Count; L1++)
            {
                a = input[L1];
                for (L2 = 0; L2 < input[L1].Length; L2++)
                {
                    lOut.Add(a[L2]);
                }
            }
            return lOut.ToArray();
        }

        public static List<T> Concatenate<T>(List<List<T>> input)
        {
            Int32 L;
            List<T> lOut = new List<T>();
            for (L = 0; L < input.Count; L++)
            {
                lOut.AddRange(input[L]);
            }
            return lOut;
        }

        public static T[] Concatenate<T>(T[] set1,T[] set2)
        {
            List<T> list = new List<T>();
            list.AddRange(set1.ToList());
            list.AddRange(set2.ToList());
            return list.ToArray();
        }

        public static T[] Skip<T>(T[] inArray, Int32 offset, Int32 stride)
        {
            Int32 L;
            List<T> ts = new List<T>();
            for (L = offset; L < inArray.Length; L += stride)
            {
                ts.Add(inArray[L]);
            }
            return ts.ToArray();
        }
    }
}
