﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Logic
{
    //licensed under the CPOL, which is here: http://www.codeproject.com/info/cpol10.aspx
    public class Permutations
    {
        public static List<List<Int32>> Permutate(int arrayItemCount)
        {
            Permutations p = new Permutations();
            p.Recursion(arrayItemCount);
            List<List<Int32>> lOut = Functional.MatrixMaps.Map(p.permutationValues, x => x - 1);
            return lOut;
        }

        private int elementLevel = -1;
        private int numberOfElements=0;
        private int[] permutationValue = new int[0];

        private List<List<int>> permutationValues = new List<List<int>>();

        private char[] inputSet;
        private char[] InputSet
        {
            get { return inputSet; }
            set { inputSet = value; }
        }

        private int permutationCount = 0;
        private int PermutationCount
        {
            get { return permutationCount; }
            set { permutationCount = value; }
        }

        /// <summary>
        /// Recursive Algorithm Source:
        /// A. Bogomolny, Counting And Listing All Permutations from Interactive Mathematics Miscellany and Puzzles
        /// http://www.cut-the-knot.org/do_you_know/AllPerm.shtml, Accessed 11 June 2009
        /// </summary>
        /// <param name="k"></param>
        private void Recursion(int k)
        {
            elementLevel++;
            permutationValue.SetValue(elementLevel, k);

            if (elementLevel == numberOfElements)
            {
                //OutputPermutation(permutationValue);
                permutationValues.Add(permutationValue.ToList());
            }
            else
            {
                for (int i = 0; i < numberOfElements; i++)
                {
                    if (permutationValue[i] == 0)
                    {
                        Recursion(i);
                    }
                }
            }
            elementLevel--;
            permutationValue.SetValue(0, k);
        }

        /// <summary>
        /// Code Source (AddItem()):
        /// A. Bogomolny, Counting And Listing All Permutations from Interactive Mathematics Miscellany and Puzzles
        /// http://www.cut-the-knot.org/do_you_know/AllPerm.shtml, Accessed 11 June 2009
        /// </summary>
        /// <param name="value"></param>
    }
}
