﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Tree
{
    [Serializable]
    public class SerializableTreeNode<T>
    {
        public List<SerializableTreeNode<T>> children = new List<SerializableTreeNode<T>>();
        //public SerializableTreeNode<T> parent;
        public String name = "";
        public T data;

        public static List<SerializableTreeNode<T>> ToSerializable(List<TreeNode<T>> inRoots)
        {
            return Functional.Maps.Map(inRoots, ToSerializable);
        }

        public static List<TreeNode<T>> ToObservable(List<SerializableTreeNode<T>> inRoots)
        {
            return Functional.Maps.Map(inRoots, ToObservable);
        }

        public static SerializableTreeNode<T> ToSerializable(TreeNode<T> inRoot)
        {
            SerializableTreeNode<T> outRoot = new SerializableTreeNode<T>();
            outRoot.data = inRoot.data;
            outRoot.name = inRoot.name;
            ToSerializable(inRoot, ref outRoot);
            return outRoot;
        }

        public static void ToSerializable(TreeNode<T> inTree, ref SerializableTreeNode<T> outTree)
        {

            int PartIndex;
            TreeNode<T> lInTree;
            SerializableTreeNode<T> lOutTree;
            for (PartIndex = 0; PartIndex < inTree.children.Count; PartIndex++)
            {
                lInTree = inTree.children[PartIndex];
                lOutTree = new SerializableTreeNode<T>();
                lOutTree.data = lInTree.data;
                lOutTree.name = lInTree.name;
                outTree.children.Add(lOutTree);
                ToSerializable(lInTree, ref lOutTree);
            }
        }

        public static TreeNode<T> ToObservable(SerializableTreeNode<T> inRoot)
        {
            TreeNode<T> outRoot = new TreeNode<T>();
            outRoot.data = inRoot.data;
            outRoot.name = inRoot.name;
            ToObservable(inRoot, ref outRoot);
            return outRoot;
        }

        public static void ToObservable(SerializableTreeNode<T> inTree, ref TreeNode<T> outTree)
        {

            int PartIndex;
            SerializableTreeNode<T> lInTree;
            TreeNode<T> lOutTree;
            for (PartIndex = 0; PartIndex < inTree.children.Count; PartIndex++)
            {
                lInTree = inTree.children[PartIndex];
                lOutTree = new TreeNode<T>();
                lOutTree.data = lInTree.data;
                lOutTree.name = lInTree.name;
                outTree.children.Add(lOutTree);
                ToObservable(lInTree, ref lOutTree);
            }
        }
    }
}
