﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Tree
{
    /// <summary>
    /// Interaction logic for TreeControl.xaml
    /// </summary>
    public partial class TreeControl : UserControl
    {
        public event Action AddSiblingClicked;
        public event Action AddSubtreeClicked;
        public event Action InsertClicked;
        public event Action DeleteClicked;
        public event Action RenameClicked;
        public event Action SelectedItemChangedClicked;
        public event Action Cut;
        public event Action Copy;
        public event Action Paste;
        public Boolean SelectedItemChangedEventIsOn = true;
        public TreeControl()
        {
            InitializeComponent();

        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            AddSiblingClicked();
        }

        private void btnAddSubTree_Click(object sender, RoutedEventArgs e)
        {
            AddSubtreeClicked();
        }

        private void btnInsert_Click(object sender, RoutedEventArgs e)
        {
            InsertClicked();
        }

        private void btnDelete_Click(object sender, RoutedEventArgs e)
        {
            DeleteClicked();
        }

        public TreeView TreeView1
        {
            get
            {
                return treeView1;
            }
        }

        public TreeViewItem TreeViewItem1
        {
            get
            {
                return treeViewItem1;
            }
        }

        private void treeView1_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (SelectedItemChangedEventIsOn == true)
            {
                SelectedItemChangedClicked();
            }
        }

        private void btnRename_Click(object sender, RoutedEventArgs e)
        {
            RenameClicked();
        }

        private void btnCut_Click(object sender, RoutedEventArgs e)
        {
            Cut();
        }

        private void btnCopy_Click(object sender, RoutedEventArgs e)
        {
            Copy();
        }

        private void btnPaste_Click(object sender, RoutedEventArgs e)
        {
            Paste();
        }


    }
}
