﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using Microsoft.VisualBasic;
namespace Tree
{
    public class TreeHelper
    {
        public static TreeNode<T> AddSibling<T>(TreeNode<T> InSelectedNode)
        {
            if (InSelectedNode == null)
            {
                MessageBox.Show("You have to select a node on the tree first.", "Select", MessageBoxButton.OK);
                return null;
            }
            String NewName = Interaction.InputBox("Enter the name of the new node.");
            if ((NewName == "") | (NewName == null))
            {
                return null;
            }
            TreeNode<T> newNode = new TreeNode<T>();
            newNode.name = NewName;
            InSelectedNode.AddSibling(newNode);
            return newNode;
        }

        public static TreeNode<T> AddSubtree<T>(TreeNode<T> InSelectedNode)
        {
            if (InSelectedNode == null)
            {
                MessageBox.Show("You have to select a node on the tree first.", "Select", MessageBoxButton.OK);
                return null;
            }
            String NewName = Interaction.InputBox("Enter the name of the new node.");
            if ((NewName == "") | (NewName == null))
            {
                return null;
            }
            TreeNode<T> newNode = new TreeNode<T>();
            newNode.name = NewName;
            InSelectedNode.children.Add(newNode);
            return newNode;
        }

        public static TreeNode<T> InsertSibling<T>(TreeNode<T> InSelectedNode)
        {
            if (InSelectedNode == null)
            {
                MessageBox.Show("You have to select a node on the tree first.", "Select", MessageBoxButton.OK);
                return null;
            }
            String NewName = Interaction.InputBox("Enter the name of the new node.");
            if ((NewName == "") | (NewName == null))
            {
                return null;
            }
            TreeNode<T> newNode = new TreeNode<T>();
            newNode.name = NewName;
            InSelectedNode.InsertSibling(InSelectedNode.Index, newNode);
            return newNode;
        }

        public static void RenameNode<T>(TreeNode<T> InSelectedNode)
        {
            if (InSelectedNode == null)
            {
                MessageBox.Show("You have to select a node on the tree first.", "Select", MessageBoxButton.OK);
                return;
            }
            TreeNode<T> lNode = InSelectedNode;
            TreeNode<T> lParent = lNode.parent;
            int lIndex = lNode.Index;
            String NewName =Interaction.InputBox("Enter the new name.","",lNode.name);
            if ((NewName == "") | (NewName == null))
            {
                return;
            }
            lNode.name = NewName;
            lParent.children.Remove(lNode);
            if (lParent.children.Count == 0)
            {
                lParent.children.Add(lNode);
            }
            else
            {
                lParent.children.Insert(lIndex, lNode);
            }
        }

        public static void DeleteNode<T>(TreeNode<T> InSelectedNode)
        {
            if (InSelectedNode == null)
            {
                MessageBox.Show("You have to select a node on the tree first.", "Select", MessageBoxButton.OK);
                return;
            }
            if (MessageBox.Show("Are you sure you want to delete the current tree node?", "Delete?", MessageBoxButton.YesNo) == MessageBoxResult.Yes)
            {
                TreeNode<T> lTreeNode = InSelectedNode;
                TreeNode<T> lParent = lTreeNode.parent;

                lParent.children.Remove(lTreeNode);
            }
        }
    }
}
