﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Functional;
namespace Tree
{
    [Serializable]
    public class TreeNode<T>
    {
        public TreeNodeCollection<T> children = new TreeNodeCollection<T>();
        public TreeNode<T> parent;
        public String name = "";
        public T data;

        public TreeNode()
        {
            children.GetParent += children_GetParent;
        }

        TreeNode<T> children_GetParent()
        {
            return this;
        }

        public List<String> Names()
        {
            List<TreeNode<T>> nodes = DepthFirst();
            return Maps.Map(nodes, x => x.name);
        }

        public List<TreeNode<T>> DepthFirst()
        {
            List<TreeNode<T>> nodes = new List<TreeNode<T>>();
            DepthFirst(this, ref nodes);
            return nodes;
        }

        public static void DepthFirst(TreeNode<T> inTree,ref List<TreeNode<T>> list)
        {
            list.Add(inTree);
            int PartIndex;
            TreeNode<T> lTree;
            for (PartIndex = 0; PartIndex < inTree.children.Count; PartIndex++)
            {
                lTree = inTree.children[PartIndex];
                DepthFirst(lTree,ref list);
            }
        }

        public void AddSibling(TreeNode<T> child)
        {
            parent.children.Add(child);
        }

        public void InsertSibling(Int32 index,TreeNode<T> child)
        {
            parent.children.Insert(index,child);
        }

        public Int32 Index
        {
            get
            {
                return parent.children.IndexOf(this);
            }
        }



        public TreeNodeCollection<T> Children { get { return children; } }
        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                name = value;
            }
        }
    }
}
