﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Functional;
using System.ComponentModel;
using System.Collections.ObjectModel;
namespace Tree
{
    [Serializable]
    public class TreeNodeCollection<T> : ObservableCollection<TreeNode<T>>
    {
        public event Func<TreeNode<T>> GetParent;
        
        public new void Add(TreeNode<T> child)
        {
            child.parent = GetParent();
            base.Add(child);
        }

        public new void Insert(Int32 index,TreeNode<T> child)
        {
            child.parent = GetParent();
            base.Insert(index,child);
        }

    }
}
